package net.londatiga.android.bluetooth;

import java.io.IOException;
import java.io.OutputStream;
import java.util.UUID;

import android.os.Bundle;
import android.app.Activity;
import android.view.*;
import android.widget.*;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
//import com.btmotor.R;
import net.londatiga.android.bluetooth.JoystickView;
import net.londatiga.android.bluetooth.JoystickView.OnJoystickMoveListener;


public class GameActivity extends Activity {
	

    public UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");


    BluetoothAdapter mBluetoothAdapter=null;
	BluetoothSocket mmSocket=null;
	BluetoothDevice mmDevice=null;
	OutputStream outStream;
	
	String velocit;
	String stato;
	double progress;
	
	String stringangle;
	String stringpower;
	String stringa;

    String mac_address;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_game);
        
        
        Bundle bundle = getIntent().getExtras();
        if(bundle.getString("indi")!= null)
        {
            mac_address= bundle.getString("indi");
            //Toast.makeText(getApplicationContext(), mac_address, Toast.LENGTH_SHORT).show();
        }
        
     
 	   final ToggleButton tgb = (ToggleButton) findViewById(R.id.tgbutton);
 	   

 	   
		final TextView angleTextView = (TextView) findViewById(R.id.angleTextView);
		final TextView powerTextView = (TextView) findViewById(R.id.powerTextView);
		final JoystickView joystick = (JoystickView) findViewById(R.id.pippo); 	   
 	   

	   
		joystick.setOnJoystickMoveListener(new OnJoystickMoveListener() {

            @Override
            public void onValueChanged(int angle, int power, int direction) {
                // TODO Auto-generated method stub
                angleTextView.setText(" " + String.valueOf(angle) + "");
                powerTextView.setText(" " + String.valueOf(power) + "%");
                
                stringangle="000"+angle;
                stringangle=stringangle.substring(stringangle.length()-3);
                
                stringpower="000"+power;
                stringpower=stringpower.substring(stringpower.length()-3);
                stringa="A"+stringangle+"P"+stringpower;
                
                sendMessageBluetooth(stringa);
                
                
                
            }
			private void sendMessageBluetooth(String message) {
				if (outStream == null) 
				{

				return; 
				}
				byte[] msgBuffer = message.getBytes();
				try 
				{
				outStream.write(msgBuffer);

				}
				catch (IOException e) 
				{
		
				}
				
			}    
		
		
		
		}, JoystickView.DEFAULT_LOOP_INTERVAL);	
	   
	      	   
        tgb.setOnClickListener(new View.OnClickListener() 
        {
        	//@Override
        	
        	public void onClick(View view)                                                                                                                               
        	{   
        		if(tgb.isChecked())
        		{
        			tgb.setBackgroundColor((0xFFFF0000 ));

        			mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        			if (mBluetoothAdapter == null) 
        			{
      				    // IL BLUETOOTH NON E' SUPPORTATO
        				Toast.makeText(GameActivity.this, "BlueTooth not supported", 5000).show();
        			}
        			else
        			{
        				if (!mBluetoothAdapter.isEnabled()) 
        				{
        				  //  NON E' ABILITATO IL BLUETOOTH
        				    System.exit(0);;
        				}
        				else
        				{
          				    //  IL BLUETOOTH E' ABILITATO 
                			
        					Toast.makeText(GameActivity.this, "ON", 1000).show();
                			
                			 // mmDevice=mBluetoothAdapter.getRemoteDevice("20:13:11:11:30:29");   //quinto  mio LC-05
        					 // mmDevice=mBluetoothAdapter.getRemoteDevice("20:13:07:18:43:94");   //Cirillo
        					 // mmDevice=mBluetoothAdapter.getRemoteDevice("20:14:03:19:02:17");   //Audiocar
        					 //   mmDevice=mBluetoothAdapter.getRemoteDevice("30:15:01:22:17:81");   //Banggood
        					    mmDevice=mBluetoothAdapter.getRemoteDevice(mac_address);
                			try
        					{
        						mmSocket=mmDevice.createRfcommSocketToServiceRecord(uuid);
        					}
        					catch (IOException e)
        					{
        						System.exit(1);
        					}
        					
        					
        					try 
        					{
        			            // CONNETTE IL DISPOSITIVO TRAMITE IL SOCKET mmSocket
        			            mmSocket.connect();
        			            outStream = mmSocket.getOutputStream();
        	        			stato="S";
        					}
        			        catch (IOException closeException) 
        			        {
            			        try 
            			        {
            			        	//TENTA DI CHIUDERE IL SOCKET
        			                mmSocket.close();
        			            } 
            			        catch (IOException ceXC) 
            			        { 
            			        	
            			        }
        			            System.exit(2);
        			        }
    			        }   //CHIUDE l'else di isEnabled
        			}  //CHIUDE l'else di mBluetoothAdapter == null
        		}  // CHIUDE if (tgb.isChecked())
        		else
        		{
        			tgb.setBackgroundColor((0xFF00FF00 ));
        			
        			//seekBarT.setProgress(0);
        			
        			try 
			        {
			        	//TENTA DI CHIUDERE IL SOCKET
			            outStream.close();
		                mmSocket.close();
		            } 
			        catch (IOException ceXC) 
			        { 
			        	
			        }
        			
        		}
        	} // CHIUDE public void OnClick(View view)
        } // CHIUDE View.OnClickListener
        ); // CHIUDE tgb.setOnClickListener(
        

        
    
    } // CHIUDE protected void onCreate(Bundle savedInstanceState)
    
    

    
    
} // CHIUDE  public class MainActivity extends Activity {
