package net.londatiga.android.bluetooth;

import java.util.ArrayList;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.app.Activity;
import android.widget.*;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;


/**
 * Main activity.
 * 
 * @author Lorensius W. L. T <lorenz@londatiga.net>
 *
 */
public class MainActivity extends Activity {
	

	private Button mScanBtn;
	private Button mStopScan;
	ArrayAdapter<String> adapter;
	private ArrayList<BluetoothDevice> mDeviceList;// = new ArrayList<BluetoothDevice>();
	private BluetoothAdapter mBluetoothAdapter;

	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity_main);


		mScanBtn 			= (Button) findViewById(R.id.btn_scan);
		mScanBtn.setEnabled(true);
		mStopScan			= (Button) findViewById(R.id.btn_stop);
		final ListView mylist = (ListView) findViewById(R.id.listView1);  
		
	
		
		mBluetoothAdapter	= BluetoothAdapter.getDefaultAdapter();
		mBluetoothAdapter.enable();
		adapter = new ArrayAdapter<String> (this,android.R.layout.simple_list_item_1); 
		
		
			mScanBtn.setOnClickListener(new View.OnClickListener() {				
				@Override
				public void onClick(View arg0) {
					mBluetoothAdapter.startDiscovery();
					mStopScan.setEnabled(true);
					
				}
			});
			

			mStopScan.setOnClickListener(new View.OnClickListener() 
			{				
				@Override
				public void onClick(View arg0) 
				{
					mBluetoothAdapter.cancelDiscovery();
					mStopScan.setEnabled(false);
					String temporanea;
					String [] array = new String[mDeviceList.size()];
					for (int i = 0; i < mDeviceList.size(); ++i) 
					{  
					   temporanea=	mDeviceList.get(i).getName() +"                    ";
					   
					   array[i]= temporanea.substring(0,14)+mDeviceList.get(i).getAddress();
					}
					Context dd=adapter.getContext();
					adapter = new ArrayAdapter<String> (dd,android.R.layout.simple_list_item_1,array); 
					mylist.setAdapter(adapter);
				}
			});			
			
			mylist.setOnItemClickListener(new AdapterView.OnItemClickListener() 
			{
		        @Override
		        public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) 
		        {

		           for (int j = 0; j < adapterView.getChildCount(); j++)
		                adapterView.getChildAt(j).setBackgroundColor(Color.TRANSPARENT);

		           // change the background color of the selected element
		           view.setBackgroundColor(Color.RED);
		            
		           String selezionato= mDeviceList.get(i).getAddress();
		           showToast(selezionato);
		           
				   Intent intent = new Intent(MainActivity.this, GameActivity.class);
					
				   intent.putExtra("indi", selezionato);
				   startActivity(intent);
		        }
				
			});
			
			
			
		IntentFilter filter = new IntentFilter();
		
		filter.addAction(BluetoothAdapter.ACTION_STATE_CHANGED);
		filter.addAction(BluetoothDevice.ACTION_FOUND);
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_STARTED);
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
		
		registerReceiver(mReceiver, filter);
	}
	
	@Override
	public void onPause() {
		if (mBluetoothAdapter != null) {
			if (mBluetoothAdapter.isDiscovering()) {
				mBluetoothAdapter.cancelDiscovery();
			}
		}
		
		super.onPause();
	}
	
	@Override
	public void onDestroy() {
		unregisterReceiver(mReceiver);
		
		super.onDestroy();
	}
	
	

	
	private void showToast(String message) {
		Toast.makeText(getApplicationContext(), message, Toast.LENGTH_SHORT).show();
	}
	
	private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
	    public void onReceive(Context context, Intent intent) {	    	
	        String action = intent.getAction();
	        
	        if (BluetoothAdapter.ACTION_STATE_CHANGED.equals(action)) {
	        	final int state = intent.getIntExtra(BluetoothAdapter.EXTRA_STATE, BluetoothAdapter.ERROR);
	        	 
	        	if (state == BluetoothAdapter.STATE_ON) {
	        		showToast("Enabled");
	        
	        	 }
	        } else if (BluetoothAdapter.ACTION_DISCOVERY_STARTED.equals(action)) {
	        	mDeviceList = new ArrayList<BluetoothDevice>();
				
				//mProgressDlg.show();
	        } else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED.equals(action)) {
	        	//mProgressDlg.dismiss();
	      

	        } else if (BluetoothDevice.ACTION_FOUND.equals(action)) {
	        	BluetoothDevice device = (BluetoothDevice) intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
		        
	        	mDeviceList.add(device);
	        	
	        	showToast("Found device " + device.getName()+ " " + device.getAddress());
	        }
	    }
	};

}